
// angular shape macros:

#macro connect_wood_radial_distortion(mul_amplitude, grid_pos)
    
    #local seg_amount = dimension_size(grid_pos, 1);
    #local f_ring_seg_shape = array[seg_amount];
    
    #for(i, 0, seg_amount - 1)
        #local f_ring_seg_shape[i] =
        function(var) {
        mul_amplitude[i][0]*pow(1 - var, 3) + 3*mul_amplitude[i][1]*pow(1 - var, 2)*var + 3*mul_amplitude[i][2]*(1 - var)*pow(var, 2) + mul_amplitude[i][3]*pow(var, 3)
        }
    
    #end
    

    
    // distortion shape:
    #local output =
    function (var_theta) {
        #for(i, 0, seg_amount - 2)
            select(
                var_theta - grid_pos[i+1][0],
                f_ring_seg_shape[i]( (var_theta - grid_pos[i][0])/(grid_pos[i][3] - grid_pos[i][0]) ),
        #end
        f_ring_seg_shape[seg_amount-1]( (var_theta - grid_pos[seg_amount-1][0])/(grid_pos[seg_amount-1][3] - grid_pos[seg_amount-1][0]) )
        #for(i, 0, seg_amount - 2)
            )
        #end        
    }
    
    output

#end

